require 'thor'
require 'sasslint'

module SassLint
  class CLI < Thor

    desc "check", "runs the Sass linter"

    # Provide CSSLint global CLI Options
    method_option :format, desc: "Indicate which format to use for output."
    method_option :listrules, desc: "Outputs all of the rules available."
    method_option :quiet, desc: "Only output when errors are present."
    method_option :errors, desc: "Indicate which rules to include as errors."
    method_option :warnings, desc: "Indicate which rules to include as warnings."
    method_option :ignore, desc: "Indicate which rules to ignore completely."
    method_option :exclude, desc: "Indicate which files/directories to exclude from being linted."
    method_option :version, desc: "Outputs the current version number."
    def check
      puts "TODO: linting that shit"
    end

    desc "import", "imports CSSLint rules"
    def import
      puts "Importing CSSLint rules"
      RuleImporter.import
    end
  end
end
